<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php include_once("config_ini.php") ; ?>
<?php include_once("version.php") ; ?>
<html>
<head>
  <title>Toppy-Web Home <?=$version?></title>
</head>

  <style>
    @import "toppy-web.css";
  </style>

<body bgcolor='#003366'>
<!-- Start of the LOGS page -->
<?php include "links.php" ?>

<?php
//echo "version=$version<br>\n" ;

 	$set_sleep=$_POST["set_sleep"];
 	$set_wake=$_POST["set_wake"];
 	$set_action=$_POST["set_action"];
 	$set_server=$_POST["set_server"];
	//echo "Command: $set_sleep | $set_wake <br>\n" ;
	if($set_action>"")
	{
	 ini_set("display_errors",0) ;
   if($ftp=ftp_connect($FTPaddress[$set_server],$FTPport[$set_server]))
   {
    ftp_login($ftp,$FTPuser[$set_server],$FTPpw[$set_server]);
    if($set_action=="sleep")     { ftp_site($ftp,"sleep") ; }
    else if($set_action=="wake") { ftp_site($ftp,"wake") ; }
		sleep(2) ; // allow time for the wake/sleep command to execute
    ftp_quit($ftp) ;
   }
	 ini_set("display_errors",1) ;
	}
		
 if (!$demo_mode)
 {
	foreach ($FTPservers as $ftpname)
	{	
   $FTPsystype[$ftpname] = "Could not connect to ".$FTPaddress[$ftpname];
	 ini_set("display_errors",0) ;
	 //echo "before ftp" ;
   if($ftp=ftp_connect($FTPaddress[$ftpname],$FTPport[$ftpname]))
   {
    $FTPsystype[$ftpname] = "Could not login to ".$FTPaddress[$ftpname];
	  //echo "inside ftp" ;
    if (ftp_login($ftp,$FTPuser[$ftpname],$FTPpw[$ftpname])) 
		{
     $FTPsystype[$ftpname] = ftp_systype($ftp);
     ftp_quit($ftp) ;
		}
   }
	 ini_set("display_errors",1) ;
	}
 }
	
?>
 <form name="sleep_wake" method="POST" action="<?=$_SERVER['SCRIPT_NAME']?>" style="display:none;">
 <input type="hidden" name="set_action" value="">
 <input type="hidden" name="set_server" value="">
 </form>

<table class="table_server">
<tr class="server_row"><td style="font-size:inherit;">ToppyWeb Home (configuration details)</td></tr>
<tr>
<td>
<table class="config_table">
 <?php do { ?>
 <tr><th colspan=2></th><th class="config_head">ToppyWeb</th></tr>
 <tr><td class="config_name">Version</td>                <td>&nbsp;</td> <td class="config_value"><?=$version?></td></tr>
 <tr><td class="config_name">Released</td>               <td>&nbsp;</td> <td class="config_value"><?=$last_updated?></td></tr>
<?php
 if ($demo_mode)
 {
  include "demo.php" ;
	break ;  // break out of the "loop"
 }
?>
 <tr><td class="config_name">Security</td>               <td>&nbsp;</td> <td class="config_value"><?="$security ( $sec_message )"?></td></tr>
<?php if (strtolower($security)<>"server") { ?> 
 <tr><td class="config_name">Current User</td>           <td>&nbsp;</td> <td class="config_value"><?=$current_user?></td></tr>
 <?php if ($current_user==$tw_user[0]) { ?>
  <tr><td class="config_name">User List</td>             <td>&nbsp;</td> <td class="config_value"><?=$str_userlist?></td></tr>
 <?PHP } ?>
<?PHP } ?>
 <tr><td class="config_name">Configuration File</td>               <td>&nbsp;</td> <td class="config_value"><?=$ini_name?></td></tr>
 
 <tr><th colspan=2></th><th class="config_head">General</th></tr>
 <tr><td class="config_name">Use TEDS</td>               <td>&nbsp;</td> <td class="config_value"><?=is_true($use_teds)?></td></tr>
 <tr><td class="config_name">Use TrecX</td>              <td>&nbsp;</td> <td class="config_value"><?=is_true($use_trecx)?></td></tr>
 <tr><td class="config_name">Use PBK</td>                <td>&nbsp;</td> <td class="config_value"><?=is_true($use_pbk)?></td></tr>
 <tr><td class="config_name">Use LCN default</td>        <td>&nbsp;</td> <td class="config_value"><?=is_true($use_LCN)?></td></tr>
 <tr><td class="config_name">Use Ajax technology</td>    <td>&nbsp;</td> <td class="config_value"><?=is_true($use_ajax)?></td></tr>
 
 <tr><th colspan=2></th><th class="config_head">Platform</th></tr>
 <tr><td class="config_name">Type</td>                   <td>&nbsp;</td> <td class="config_value"><?=$platform?></td></tr>
 <tr><td class="config_name">Operating System</td>       <td>&nbsp;</td> <td class="config_value"><?=PHP_OS." (from PHP)"?></td></tr>
 <tr><td class="config_name">PHP Version</td>            <td>&nbsp;</td> <td class="config_value"><?=PHP_VERSION?></td></tr>
 <tr><td class="config_name">Server Software</td>        <td>&nbsp;</td> <td class="config_value"><?=$_SERVER["SERVER_SOFTWARE"]?></td></tr>
 <tr><td class="config_name">System Time Zone</td>       <td>&nbsp;</td> <td class="config_value"><?="GMT".substr(date("r"),-5)." (".date("T").")"?></td></tr>
 <tr><td class="config_name">System Time</td>            <td>&nbsp;</td> <td class="config_value"><?=date("h:ia, l, jS F Y")?></td></tr>
 <tr><td class="config_name">Local Working Folder</td>   <td>&nbsp;</td> <td class="config_value"><?=$local_files?></td></tr>
 
<?php if ($use_teds) { ?>
 <tr><th colspan=2></th><th class="config_head">TED/S</th></tr>
 <tr><td class="config_name">TED/S Type</td>             <td>&nbsp;</td> <td class="config_value"><?=$teds_type?></td></tr>
 <tr><td class="config_name">TED/S Folder</td>           <td>&nbsp;</td> <td class="config_value"><?=$teds_location?></td></tr>
 <tr><td class="config_name">TED log</td>           <td>&nbsp;</td> <td class="config_value"><?=$teds_log?></td></tr>
 <tr><td class="config_name">TED Timers log</td>           <td>&nbsp;</td> <td class="config_value"><?=$teds_timers?></td></tr>
<?php } 

foreach ($FTPservers as $ftpname ) {
?>  
 <tr><th colspan=2 class="config_head"><?=$ftpname?>     </th><th class="config_head">FTP server<?=sleepwake($ftpname)?></th></tr>
 <tr><td class="config_name">FTP Server Type</td>        <td>&nbsp;</td> <td class="config_value"><?=$FTPtype[$ftpname]?></td></tr>
 <tr><td class="config_name">FTP Server Name</td>        <td>&nbsp;</td> <td class="config_value"><?=$FTPaddress[$ftpname]?></td></tr>
 <tr><td class="config_name">FTP Server Port</td>        <td>&nbsp;</td> <td class="config_value"><?=$FTPport[$ftpname]?></td></tr>
 <tr><td class="config_name">FTP System Type</td>        <td>&nbsp;</td> <td class="config_value"><?=$FTPsystype[$ftpname]?></td></tr>
<?php } ?>
 
<?php  
foreach ($MyToppies as $toppyname ) {
?>  
 <tr><th colspan=2 class="config_head"><?=$toppyname?></th><th class="config_head">Topfield</th></tr>
 <tr><td class="config_name">Use LCN for timers</td>     <td>&nbsp;</td> <td class="config_value"><?=is_true($TFuseLCN[$toppyname])?></td></tr>
 <tr><td class="config_name">Topfield EPG data</td>      <td>&nbsp;</td> <td class="config_value"><?=$TFepgdata[$toppyname]?></td></tr>
 <tr><td class="config_name">Topfield Data Files</td>    <td>&nbsp;</td> <td class="config_value"><?=$TFdatafiles[$toppyname]?></td></tr>
 <tr><td class="config_name">Topfield Program Files</td> <td>&nbsp;</td> <td class="config_value"><?=$TFprogramfiles[$toppyname]?></td></tr>
 <tr><td class="config_name">Active Rec/Play List</td>   <td>&nbsp;</td> <td class="config_value"><?=($epg_recplay_rem."/".$epg_recplay)?></td></tr>
 <tr><td class="config_name">Current Timer List</td>     <td>&nbsp;</td> <td class="config_value"><?=($epg_timers_rem."/".$epg_timers)?></td></tr>
 <tr><td class="config_name">Pending Timer List</td>     <td>&nbsp;</td> <td class="config_value"><?=($set_timers_rem."/".$set_timers_tgd)?></td></tr>
 <tr><td class="config_name">HDD size</td>               <td>&nbsp;</td> <td class="config_value"><?=number_format($TFhdd[$toppyname],0,".",",")?></td></tr>
 <tr><td class="config_name">Initial view</td>           <td>&nbsp;</td> <td class="config_value"><?=is_true($TFexpandServer[$toppyname],"Expanded","Collapsed")?></td></tr>
 <tr><td class="config_name">Initial Folder view</td>    <td>&nbsp;</td> <td class="config_value"><?=is_true($TFexpandFolders[$toppyname],"Expanded","Collapsed")?></td></tr>
<?php } ?>
 
<?php  
foreach ($RECservers as $servername ) {
?>  
 <tr><th colspan=2 class="config_head"><?=$servername?></th><th class="config_head">REC Files Server</th></tr>
 <tr><td class="config_name">REC Files folder</td>    <td>&nbsp;</td> <td class="config_value"><?=$TFdatafiles[$servername]?></td></tr>
 <tr><td class="config_name">HDD size</td>               <td>&nbsp;</td> <td class="config_value"><?=number_format($TFhdd[$servername],0,".",",")?></td></tr>
 <tr><td class="config_name">Initial view</td>           <td>&nbsp;</td> <td class="config_value"><?=is_true($TFexpandServer[$servername],"Expanded","Collapsed")?></td></tr>
 <tr><td class="config_name">Initial Folder view</td>    <td>&nbsp;</td> <td class="config_value"><?=is_true($TFexpandFolders[$servername],"Expanded","Collapsed")?></td></tr>
<?php } ?>
 
 <tr><th colspan=2></th><th class="config_head">Recordings</th></tr>
 <tr><td class="config_name">Folder</td>                 <td>&nbsp;</td> <td class="config_value"><?=$recordings_dir?></td></tr>
 <tr><td class="config_name">Initial sort</td>           <td>&nbsp;</td> <td class="config_value"><?=$files_initial_sort?></td></tr>
 <tr><td class="config_name">Force Windows Names</td>    <td>&nbsp;</td> <td class="config_value"><?=is_true($force_win_names)?></td></tr>
 
 <tr><th colspan=2></th><th class="config_head">Channel Details</th></tr>
 <?php foreach ($chn_names as $key => $value) 
 { 
 	echo "<tr><td class='config_name'>$value".has_lcn(array_search($value,$lcn_chn_trans))."</td><td>&nbsp;</td><td class='config_value'>".$key.epg_source_name($epg_type,$value).has_alternate($chn_alternate[$value]).has_hdtv($chn_hdtv[$value]).is_no_EPG($chn_hide[$value])."</td></tr>\n" ; 
 } 
 ?>
 
 <tr><th colspan=2></th><th class="config_head">EPG display</th></tr>
 <tr><td class="config_name">Show EPG</td>            <td>&nbsp;</td> <td class="config_value"><?=is_true($show_epg)?></td></tr>
<? if ($show_epg) { ?>
 <tr><td class="config_name">EPG Time Zone</td>       <td>&nbsp;</td> <td class="config_value"><?="GMT".$time_zone?></td></tr>
 <tr><td class="config_name">EPG source type</td>     <td>&nbsp;</td> <td class="config_value"><?=$epg_type?></td></tr>
 <? if ($epg_type=="xml") { ?>
  <tr><td class="config_name">XML source</td>         <td>&nbsp;</td> <td class="config_value"><?=$epg_xmlSource?></td></tr>
 <? } ?>
 <? if ($epg_type=="ice") { ?>
  <tr><td class="config_name">IceTV folder</td>       <td>&nbsp;</td> <td class="config_value"><?=$epg_ice_loc?></td></tr>
  <tr><td class="config_name">IceTV time offset</td>  <td>&nbsp;</td> <td class="config_value"><?=($ice_offset_seconds/3600)." hours"?></td></tr>
 <? } ?>
 <? if ($epg_type=="tgd") { ?>
  <tr><td class="config_name">TGD folder</td>         <td>&nbsp;</td> <td class="config_value"><?=$epg_tgd_loc?></td></tr>
  <tr><td class="config_name">Use yesterday's TGD</td><td>&nbsp;</td> <td class="config_value"><?=is_true($epg_tgd_yesterday)?></td></tr>
  <tr><td class="config_name">Use today's TGD</td>    <td>&nbsp;</td> <td class="config_value"><?=is_true($epg_tgd_start)?></td></tr>
  <tr><td class="config_name">Use tomorrow's TGD</td> <td>&nbsp;</td> <td class="config_value"><?=is_true($epg_tgd_end)?></td></tr>
 <? } ?>
 <? if ($epg_type=="mei") { ?>
  <tr><td class="config_name">MEI folder</td>         <td>&nbsp;</td> <td class="config_value"><?=$epg_mei_loc?></td></tr>
  <tr><td class="config_name">MEI identifier</td>     <td>&nbsp;</td> <td class="config_value"><?=$epg_mei_identifier?></td></tr>
  <tr><td class="config_name">MEI <?=$epg_mei_identifier?> refresh time</td>     <td>&nbsp;</td> <td class="config_value"><?=$epg_mei_cachetime?> minutes</td></tr>
  <tr><td class="config_name">MEI epg_upload.ini</td> <td>&nbsp;</td> <td class="config_value"><?=$epg_mei_epgupload?></td></tr>
 <? } ?>

 <tr><td class="config_name">EPG cache enabled</td>   <td>&nbsp;</td> <td class="config_value"><?=is_true($cache_epg_enabled)?></td></tr>
 <? if ($cache_epg_enabled) { ?>
  <?PHP $x = "".duration_display($cache_epg_today).", ".duration_display($cache_epg_tomorrow).", ".duration_display($cache_epg_beyond) ; ?>
  <tr><td class="config_name">Cache expiry (Today, Tomorrow, Beyond)</td>     <td>&nbsp;</td> <td class="config_value"><?=$x?></td></tr>
 <? } ?>

 <tr><td class="config_name">Show descriptions</td>   <td>&nbsp;</td> <td class="config_value"><?=is_true(!$hide_description)?></td></tr>
 <tr><td class="config_name">Minimum duration</td>    <td>&nbsp;</td> <td class="config_value"><?=$minimum_duration?> minutes</td></tr>
 <tr><td class="config_name">Screen width</td>        <td>&nbsp;</td> <td class="config_value"><?=$screen_width?> pixels</td></tr>
 <tr><td class="config_name">Hour height</td>         <td>&nbsp;</td> <td class="config_value"><?=$hour_height?> pixels</td></tr>
 <tr><td class="config_name">Popover maximum</td>     <td>&nbsp;</td> <td class="config_value"><?=$mouseover_display?> minutes</td></tr>
 <tr><td class="config_name">Popover compare</td>     <td>&nbsp;</td> <td class="config_value"><?=is_true($mouseover_compare_inner)?></td></tr>
 <tr><td class="config_name">Popover descriptions</td><td>&nbsp;</td> <td class="config_value"><?=is_true($mouseover_desc)?></td></tr>
 <? if ($epg_type=="ice") { ?>
 <tr><th colspan=2></th><th class="config_head">ICE Channel translations</th></tr>
  <? foreach($ice_chn_trans as $index => $value) { ?>
	 <tr><td class="config_name"><?=$index?></td>       <td>&nbsp;</td> <td class="config_value"><?=$value?></td></tr>
	<? } ?>
 <? } ?>
<? } ?>
 <tr><th colspan=2></th><th class="config_head">Available log files</th></tr>
	 <tr><td class="config_name">Show Logs</td>         <td>&nbsp;</td> <td class="config_value"><?=is_true($show_logs)?></td></tr>
<? if ($show_logs) { ?>
 <?php foreach ($list_file_entry as $key => $value) { echo "<tr><td class='config_name'>$value</td><td>&nbsp;</td><td class='config_value'>".$list_file_type[$key].":".$list_file_server[$key]." => ".$list_file_loc[$key].separator($list_file_type[$key]).$list_file_name[$key]."</td></tr>\n" ; } ?>
 <? } ?>
 <tr><th colspan=2></th><th class="config_head">Browser details</th></tr>
 <tr><td class="config_name">Current Browser</td>        <td>&nbsp;</td> <td class="config_value"><?=str_replace(";",";<br />",str_replace(")",")<br />",str_replace("(","<br />(",$_SERVER["HTTP_USER_AGENT"])))?></td></tr>
 <?php } while (false) ; ?>
</table>
</td>
</tr>
</table>

<?PHP //echo "ShowDiag = ".yes_if_true($show_diag)."<br>\n" ; ?>
<?php 
 add_diag("finished page") ;
 if($show_diag) { create_diag() ;  }
?>

</body>
</html>

<?PHP

 function epg_source_name($etype,$value)
 {
 	global $epg_type,$ice_chn_trans,$xml_chn_trans ;
 	
  if      ($epg_type=="ice") { return ", IceTV=".array_search($value,$ice_chn_trans) ; }
  else if ($epg_type=="xml") { return ", XML=".array_search($value,$xml_chn_trans) ; }
	else            { return "" ; }
 }

 function has_lcn($value)
 {
  if (is_int($value)) { return " ($value)" ; }
	else            { return "" ; }
 }

 function has_alternate($value)
 {
  if ($value<>"") { return ", Alternate=$value" ; }
	else            { return "" ; }
 }

 function has_hdtv($value)
 {
  if ($value<>"") { return ", HDTV=$value" ; }
	else            { return "" ; }
 }

 function is_no_EPG($flag)
 {
  if ($flag) { return " (No EPG)" ; }
	else       { return "" ; }
 }

 function duration_display($duration)
 {
 	$duration_display = "";
 	$hours = intval($duration /60) ;
 	$minutes = $duration % 60 ;
 	//echo "$duration $hours $minutes\n" ;
 	if($hours==1) {$duration_display.="$hours hour ";}
 	if($hours>1) {$duration_display.="$hours hours ";}
 	if($minutes==1){$duration_display.="$minutes minute ";}
 	if($minutes>1){$duration_display.="$minutes minutes ";}
 	return $duration_display ;
 }
 
 function separator($flag)
 {
  if ($flag=="ftp") { return "/" ; }
	else       { return DIRECTORY_SEPARATOR ; }
 }
 
 function sleepwake($ftpname)
 {
  global $FTPtype ;
	
	if ($FTPtype[$ftpname]<>"ftp4t") { return "" ; }
	$s  = "&nbsp;<input type='button' name='sleep' value='Sleep'   onclick='set_sleepwake(\"sleep\",\"$ftpname\")'>" ;
	$s .= "&nbsp;<input type='button' name='wake'  value='Wake up' onclick='set_sleepwake(\"wake\",\"$ftpname\")'>" ;
	return $s ;
 }
?>
<script language="JavaScript" type="text/javascript">
<!--
 function set_sleepwake(action,servername)
 {
  theForm = document.sleep_wake ;
	theForm.set_action.value = action ;
	theForm.set_server.value = servername ;
	theForm.submit()
 }
//-->
</script>
