<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

* Redistributions must retain the above copyright
notice, this list of conditions and the following disclaimer.

* The name of John Stevens may not
be used to endorse or promote products derived from this
software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php include_once ("config_ini.php"); ?>
<?php include_once ("version.php"); ?>
<html>
<head>
  <title>Toppy-Web Logfiles <?= $version ?></title>
</head>

  <style>
    @import "toppy-web.css";
  </style>

<body>
<!-- Start of the LOGS page -->
<?php
$show_log = $_POST["show_log"];
$set_logname = $_POST["set_logname"];
//$show_log=$_GET["show_log"];
//$set_logname=$_GET["set_logname"];

?>

<?php include "links.php" ?>

<?php
echo "<div style='clear: both;'>\n";

if ($show_log)
{
  if ($list_file_type[$set_logname] == "ftp")
  {
    //if(array_key_exists($list_file_server,$set_logname))
    if (array_key_exists($list_file_server[$set_logname], $FTPtype))
    {
      if ($FTPtype[$list_file_server[$set_logname]] == "ftp4t")
      {
        // Issue a WAKEUP command in case the the server is sleeping
        ini_set("display_errors", 0);
        if ($ftp = ftp_connect($ftp_server, $ftp_port))
        {
          ftp_login($ftp, $user_name, $user_pw);
          if (ftp_site($ftp, "wakeup"))
          {
            sleep(2);
          }
          ftp_quit($ftp);
        }
        ini_set("display_errors", 1);
      }

      if ($ftp = ftp_connect($FTPaddress[$list_file_server[$set_logname]], $FTPport[$list_file_server[$set_logname]]))
      {
        ftp_login($ftp, $FTPuser[$list_file_server[$set_logname]], $FTPpw[$list_file_server[$set_logname]]);
        ftp_chdir($ftp, $list_file_loc[$set_logname]);

        if (ftp_size($ftp, $list_file_name[$set_logname]) > 0)
        {
          $get = ftp_get($ftp, $local_files . DIRECTORY_SEPARATOR . $list_file_name[$set_logname], $list_file_name[$set_logname],
            FTP_ASCII);
          //echo "file=".$local_files."\\".$list_file_name[$set_logname]."<br>\n" ;
          list_file($local_files . DIRECTORY_SEPARATOR . $list_file_name[$set_logname]);
        } else
        {
          echo "The ftp file <b>" . $list_file_loc[$set_logname] . "/" . $list_file_name[$set_logname] .
            "</b> does not exist";
        }
        ftp_quit($ftp);
      } else
      {
        echo "FTP " . $list_file_server[$set_logname] . " could not connect";
      }
    } else
    {
      echo "FTP server " . $list_file_server[$set_logname] . " not defined";
    }
  } else
  {
    list_file($list_file_loc[$set_logname] . DIRECTORY_SEPARATOR . $list_file_name[$set_logname]);
  }
}

echo "</div>\n";

function list_file($filename)
{
  echo "<div id='log_display'><table>\n";
  $rows = file($filename);
  echo "<!-- filename=$filename(" . count($rows) . ") -->\n";
  $lastblank = false;
  //foreach($rows as $line) { echo "$line<br>\n" ; }
  foreach ($rows as $line)
  {
    $line = trim($line);
    if (strlen($line) > 0)
    {
      $lastblank = false;
      if (strpos($line, "\t"))
      {
        echo "<tr><td>" . str_replace("\t", "</td><td&nbsp;</td><td>", $line) . "</td></tr>\n";
      } else
      {
        echo "<tr><td colspan=99>" . str_replace("\t", "</td><td&nbsp;</td><td>", $line) . "</td></tr>\n";
      }
    } else
      if ($lastblank)
      {
      } else
      {
        echo "<tr><td>&nbsp;</td></tr>\n";
        $lastblank = true;
      }
  }
  echo "</table></div>\n";
}

?>
</body>
</html>